#
# spec file for package kvm (Version 36)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# icecream 0
# usedforbuild    SDL SDL-devel aaa_base aalib aalib-devel acl alsa alsa-devel alsa-utils attr audit-libs autoconf automake bash binutils bzip2 coreutils cpio cpp cpp42 cracklib cvs dialog diffutils file filesystem fillup findutils fontconfig fontconfig-devel freetype2 freetype2-devel gawk gcc gcc42 gdbm gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kernel-source kernel-syms less libacl libasound2 libattr libbz2-1 libbz2-devel libdb-4_5 libexpat-devel libexpat1 libgcc42 libgomp42 libltdl-3 libmudflap42 libreadline5 libstdc++-devel libstdc++42 libstdc++42-devel libtool libuuid1 libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp ncurses ncurses-devel net-tools netcfg pam pam-modules patch pciutils pciutils-ids perl perl-base permissions pkg-config popt rpm sed sysvinit tar texinfo timezone util-linux xorg-x11-devel xorg-x11-fonts-devel xorg-x11-libICE xorg-x11-libICE-devel xorg-x11-libSM xorg-x11-libSM-devel xorg-x11-libX11 xorg-x11-libX11-devel xorg-x11-libXau xorg-x11-libXau-devel xorg-x11-libXdmcp xorg-x11-libXdmcp-devel xorg-x11-libXext xorg-x11-libXext-devel xorg-x11-libXfixes xorg-x11-libXfixes-devel xorg-x11-libXmu xorg-x11-libXmu-devel xorg-x11-libXp xorg-x11-libXp-devel xorg-x11-libXpm xorg-x11-libXpm-devel xorg-x11-libXprintUtil xorg-x11-libXprintUtil-devel xorg-x11-libXrender xorg-x11-libXrender-devel xorg-x11-libXt xorg-x11-libXt-devel xorg-x11-libXv xorg-x11-libXv-devel xorg-x11-libfontenc xorg-x11-libfontenc-devel xorg-x11-libs xorg-x11-libxcb xorg-x11-libxcb-devel xorg-x11-libxkbfile xorg-x11-libxkbfile-devel xorg-x11-proto-devel xorg-x11-util-devel xorg-x11-xtrans-devel zlib zlib-devel


Name:           kvm
License:        BSD 3-Clause; GPL v2 only; GPL v2 or later; LGPL v2.1 or later; X11/MIT
Group:          System/Kernel
Summary:        Kernel-based Virtual Machine
Url:            http://kvm.qumranet.com/
Version:        36
Release:        13.1
ExclusiveArch:  %ix86 x86_64
Source0:        %name-%version.tar.bz2
Source1:        60-kvm.rules
Patch01:        qemu-datadir.diff
Patch02:        qemu-sparse.diff
Patch03:        kvm-no-kvm-disabled.patch
# patches from upstream qemu
Patch50:        qemu-cvs-atapi.patch 
Patch51:        kvm-rtl8139-mmio-regions.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  SDL-devel alsa alsa-devel perl texinfo
%define use_kmp 1
%if %use_kmp
Requires:       kvm-kmp
%endif
# Can't use --with-patched-kernel with kvm-36 on i386, so for now also on 10.3:
BuildRequires:  kernel-syms

%description
KVM (for Kernel-based Virtual Machine) is a virtual machine for Linux
which is based on hardware virtualization extensions (Intel VT and
AMD-V) and an adapted version of qemu to enable full hardware
simulation as far as needed to boot many PC operating systems in
unmodified form, including Linux, and Windows, inside a kernel-based
virtual machine.

Note: KVM is not yet ready for production use and has known issues
which you can find by searching the Novell bugzilla:
http://bugzilla.novell.com

KVM depends on Intel VT and AMD-V and does not run on CPUs without
these extensions. qemu can be used on those, with some performance
penalty, instead.

As the hardware simulation used for KVM is based on qemu, virtual
machines can be moved between QEMU and KVM hosts without problem.

The package libvirt contains libvirtd, a simple hypervisor for managing
multible QEMU and KVM virtual machines on one host machine. The
included virsh allows to define virtual machines using xml files and
allows some simple management of such virtual machines on the command
line. virt-manager is GUI for connecting to, and controlling virtual
machines based on libvirt.



Authors:
--------
    Avi Kivity   <avi@qumranet.com>
    Yaniv Kamay  <yaniv@qumranet.com>
    Dor Laor     <dor.laor@qumranet.com>

%debug_package
%package devel

Summary:        Kernel-based Virtual Machine
Group:          System/Kernel

%description devel
KVM (for Kernel-based Virtual Machine) is a virtual machine for Linux
which is based on hardware virtualization extensions (Intel VT and
AMD-V) and an adapted version of qemu to enable full hardware
simulation as far as needed to boot many PC operating systems in
unmodified form, including Linux, and Windows, inside a kernel-based
virtual machine.

KVM depends on Intel VT and AMD-V and does not run on CPUs without
these extensions. qemu can be used on those, with some performance
penalty, instead.

As the hardware simulation used for KVM is based on qemu, virtual
machines can be moved between QEMU and KVM hosts without problem.

The package libvirt contains libvirtd, a simple hypervisor for managing
multible QEMU and KVM virtual machines on one host machine. The
included virsh allows to define virtual machines using xml files and
allows some simple management of such virtual machines on the command
line. virt-manager is GUI for connecting to, and controlling virtual
machines based on libvirt.



Authors:
--------
    Avi Kivity   <avi@qumranet.com>
    Yaniv Kamay  <yaniv@qumranet.com>
    Dor Laor     <dor.laor@qumranet.com>

%if %use_kmp
%suse_kernel_module_package debug kdump um xen xenpae

%package KMP
License:        BSD 3-Clause; GPL v2 only; GPL v2 or later; LGPL v2.1 or later; X11/MIT
Summary:        Updated kernel modules for KVM (Kernel-based Virtual Machine)
Group:          System/Kernel

%description KMP
This package contains updated kernel modules which are recommended for
enhanced functionality of KVM. The Linux kernel rpm already contains
kvm modules, but with this package installed and the modules of this
package loaded, certain fixes which are not yet available in the kernel
rpm.

To verify the kernel to which this package is built for, compare the
postfix of this package has after "kvm-kmp-" with the postfix after
"kernel-", e.g. kvm-kmp-default contains updated modules for the
kernel-default with the exact same version number.

To take advantage of KVM in general, you need qemu-kvm (which is
included in the package kvm) which contains the PC hardware simulation
that is needed for full virtualisation.

KVM guests implemented using qemu-kvm can be monitored using libvirt
which contains a hypervisor for managing multible QEMU and KVM and Xen
virtual machines. virt-manager provides a graphical application for
connecting to and controlling virtual machines based on libvirt.



Authors:
--------
    Avi Kivity   <avi@qumranet.com>
    Yaniv Kamay  <yaniv@qumranet.com>
    Dor Laor     <dor.laor@qumranet.com>

%endif

%prep
%setup -q
%patch01 -p1 -b .datadir
%patch02 -p1 -b .sparse
%patch03 -p1 -b .no-kvm-disabled
%patch50 -p1 -b .atapi
%patch51 -p1 -b .rtl8139-mmio-regions
%define kvmcflags %(optflags="%optflags";optflags="${optflags//-fstack-protector/}";echo "${optflags//-D_FORTIFY_SOURCE=?/}")
mkdir suse-kernel
./configure --prefix=%{_prefix}  --qemu-cc='gcc %kvmcflags' --disable-gcc-check
# Let this directoy also use the optflags:
sed -i 's/CFLAGS =/CFLAGS +=/' user/Makefile
echo "CFLAGS=%kvmcflags" >> user/config.mak

%build
export EXTRA_CFLAGS="-DVERSION=%version"
# kernel modules
%if %use_kmp
for flavor in %flavors_to_build; do
    rm -rf suse-kernel/$flavor
    cp -r kernel suse-kernel/$flavor
    make -C /usr/src/linux-obj/%_target_cpu/$flavor modules \
	M=$PWD/suse-kernel/$flavor
done
%endif
make -C user
cd qemu
make

%install
# kernel modules
%if %use_kmp
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=weak-updates
for flavor in %flavors_to_build; do
    make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install \
	 M=$PWD/suse-kernel/$flavor
done
%endif
make DESTDIR=%{buildroot} WANT_MODULE="" install
mv qemu/qemu-doc.html qemu/qemu-kvm.html
cd %{buildroot}
rm -r .{%_bindir/qemu-img,%_datadir/{doc,qemu-kvm/{openbios-sparc32,ppc_rom.bin}}}
rm -r .{%_mandir/man1/qemu-img.1,%_includedir,%_libdir}
mv .%_bindir/{qemu*,qemu-kvm}
mv .%_mandir/man1/{qemu.1,qemu-kvm.1}
chmod 644 .%_mandir/man1/*
install -D -m 644 %{SOURCE1} %{buildroot}/etc/udev/rules.d/60-kvm.rules

%pre
/usr/sbin/groupadd -r kvm 2>/dev/null || :

%files
%defattr(-,root,root)
%doc qemu/qemu-kvm.html
%attr(750,root,kvm) %{_bindir}/qemu-kvm
%{_datadir}/qemu-kvm
%config /etc/udev/rules.d/60-kvm.rules
%_mandir/man1/qemu-kvm.1.gz

%changelog
* Tue Aug 28 2007 - bk@suse.de
- based unpon version in opensue buildservice by dbahi/kraxel
